> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Runner Token

> Creates a new authentication token for a runner.

`Unary` · [`Runners`](https://ona.com/docs/api-reference/generated/runner/overview)

Creates a new authentication token for a runner.

Use this method to:

* Generate runner credentials
* Renew expired tokens
* Set up runner authentication

Note: This does not expire previously issued tokens.

### Examples

* Create token:

  Creates a new token for runner authentication.

  ```yaml theme={null}
  runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.RunnerService/CreateRunnerToken
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.RunnerService/CreateRunnerToken" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "runnerId": "<runner-id>"
}'
```

```python Python theme={null}
import gitpod.v1.runner_pb2 as runner_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = runner_pb2.CreateRunnerTokenRequest(
    runner_id="<runner-id>",
)
response = ona.services.runner.create_runner_token(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { CreateRunnerTokenRequestSchema } from "@gitpod/sdk/gitpod/v1/runner_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(CreateRunnerTokenRequestSchema, {
    runnerId: "<runner-id>",
  });
  const response = await ona.services.runner.createRunnerToken(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.CreateRunnerTokenRequest{
		RunnerId: "<runner-id>",
	})
	response, err := ona.Services.Runner.CreateRunnerToken(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "runnerId": "<runner-id>"
}
```

## Request

`gitpod.v1.CreateRunnerTokenRequest`

| Field | Type | Required | Description |
| - | - | - | - |
| `runnerId` | string | No | Constraints: `string.uuid=true`. |

## Response

`gitpod.v1.CreateRunnerTokenResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `accessToken` | string | No | **Deprecated.** deprecated, will be removed. Use exchange\_token instead. |
| `exchangeToken` | string | No | exchange\_token is a one-time use token that should be exchanged by the runner for an access token, using the IdentityService.ExchangeToken rpc. The token expires after 24 hours. |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.